-- touchKeyboard.lua

	
	touchKeyboard = {
  init = {}
}
	
-- List of sound sources
local soundSources = {
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-001.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-002.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-003.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-004.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-005.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-006.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-007.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-008.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-009.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-010.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-011.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-012.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-013.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-014.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-015.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-016.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-017.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-018.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-019.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-020.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-021.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-022.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-023.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-024.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-025.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-026.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-027.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-028.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-029.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-030.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-031.wav", "static"),
    love.audio.newSource("assets/unicae_games_keyboard_soundpack_1/Single Keys/keypress-032.wav", "static")
}

-- Function to play a random key stroke
function playRandomeKeyStroke()
    local randomIndex = love.math.random(1, #soundSources)
    soundSources[randomIndex]:setVolume(1)
    soundSources[randomIndex]:play()
end

--touchKeyboard = {}

-- Define the keyboard layout
keyboardLayout = {
     {"1", "2", "3", "4", "5", "6", "7", "8", "9", "0","del"},
    {"Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P","ret"},
    {"Upper2", "A", "S", "D", "F", "G", "H", "J", "K", "L", ""},
    {"Upper", "<", "Z", "X", "C", "V", "B", "N", "M", "", "", ""},
    --{"", "", "", "", "", "", "", "", "", ""}, -- Empty row
    {"Space"} -- Space key row

}

-- Define the keyboard layout
keyboardLayoutLandscape = {
    {"^", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "?", "'", "del"},
    {"Tab", "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "Ü", "+", "spr"},
    {"Upper2", "A", "S", "D", "F", "G", "H", "J", "K", "L", "Ö", "Ä", "#", "ret2"},
    {"Upper", "<", "Z", "X", "C", "V", "B", "N", "M", ",", "up", "." , "-", },
    {"strg", "linux", "alt", "Space", "left", "down", "right"} -- Space key row

}



-- Function to select the appropriate keyboard layout based on orientation
function selectKeyboardLayout()
    if KeyboardOrientation == "landscape" then
        return keyboardLayoutLandscape
    else
        return keyboardLayout
    end
end

-- Define the position and size of the keyboard
--keyboardX = 50
--keyboardY = 100
    -- Center the keyboard on the screen
    local width, height = love.graphics.getDimensions()
    local centerX = width / 2
    local centerY = height / 2 
keyoffsetX, keyoffsetY = 0, width * 0.8
--keyoffsetX, keyoffsetY = 0, width * 0.5
keyboardX, keyboardY = 0, 0
keyWidth = 68
keyHeight = 100
keyPadding = 2

-- Initialize the virtual keyboard module
--touchKeyboard = {}
touchKeyboard.init = {}
-- Initialize the virtual keyboard
function touchKeyboard:init()
	
    self.selectedKey = nil
    self.keyTransparency = {} -- Table to store transparency for each key
    self.transparencyDecreaseRate = 0.5 -- Adjust the rate as needed
	
end


function touchKeyboard:touchpressed(x, y)
    --[[
    print("Touch pressed at coordinates:", x, y)
     x = x or 0 -- Ensure x is not nil
    y = y or 0 -- Ensure y is not nil
    cursorX = cursorX or 0
    cursorY = cursorY or 0
    self.x = self.x or 0
    self.y = self.y or 0
     
    -- Calculate the cursor position based on touch coordinates
    local cursorX = math.floor((x - self.x) / keyWidth)
    local cursorY = math.floor((y - self.y) / keyHeight)
    
    -- Update the cursor position
    if cursorX >= 1 and cursorX <= #layout[1] and cursorY >= 1 and cursorY <= #layout then
        print("Selected key:", layout[cursorY][cursorX])
        self.selectedKey = layout[cursorY][cursorX]
        
        -- Reset the transparency for the selected key
        self.keyTransparency[self.selectedKey] = 1
        
        -- Set the cursor position in the code editor
        if code_editor then
            code_editor.cursor = {
                x = cursorX,
                y = cursorY
            }
        end
        
        -- Add mobile vibration (if supported)
        love.system.vibrate(0.1)
        
        -- Return early to prevent further execution
        return
    end
    
    
    --]]
    local layout = selectKeyboardLayout() -- Select the appropriate keyboard layout
    for i, row in ipairs(layout) do
        local rowOffset = (i - 1) * 0.5 * (keyWidth + keyPadding) -- Offset for row displacement
        for j, key in ipairs(row) do
            local keyX = rowOffset + (j - 1) * (keyWidth + keyPadding)
            local keyY = (i - 1) * (keyHeight + keyPadding)
            
            local keyWidthMultiplier = 1 -- Default width multiplier
            local keyOffsetX = 0
                   -- Determine the width multiplier of the current key
            local keyWidthMultiplier = 1
          
   			
			   -- Adjust offsets and multipliers based on key type
				if key == "strg" then
					keyOffsetX = -keyWidth * 2
					keyWidthMultiplier = 2.0
			elseif key == "linux" or key == "alt" then
					keyOffsetX = -keyWidth * 1
					keyWidthMultiplier = 1.0
            elseif key == "alt gr" or key == "fn" or key == "fn2" then
                keyOffsetX = keyWidth * 5
                keyWidthMultiplier = 1.0
            elseif key == "left" or key == "down" or key == "right" then
                keyOffsetX = keyWidth * 5
                keyWidthMultiplier = 1.0
            elseif key == "strg2" then
                keyOffsetX = keyWidth * 5
                keyWidthMultiplier = 1.5
            elseif key == "Space" then
                keyOffsetX = -keyWidth * 1
                keyWidthMultiplier = 7
            elseif key == "Upper" or key == "Upper2" then
                keyOffsetX = -keyWidth * 1.5
                keyWidthMultiplier = 2.49
            elseif key == "Upper3" then
                keyWidthMultiplier = 1.9
            elseif key == "Tab" then
                keyOffsetX = -keyWidth * 0.5
                keyWidthMultiplier = 1.5
            elseif key == "ret" then
				keyWidthMultiplier = 1.9
            elseif key == "ret2" then
				keyWidthMultiplier = 1.6
            elseif key == "del" then
				keyWidthMultiplier = 2.4
            end
            
            
            if x >= keyX and x <= keyX + keyOffsetX + keyWidth * keyWidthMultiplier + keyPadding * (keyWidthMultiplier - 1)
                and y >= keyY + keyoffsetY and y <= keyY + keyoffsetY  + keyHeight then
                print("Selected key:", key)
                self.selectedKey = key
                
                -- Reset the transparency for the selected key
                self.keyTransparency[key] = 1
                
                -- Add mobile vibration (if supported)
                love.system.vibrate(0.1)
                
                return self.selectedKey
            end
        end
    end
    
    -- If no key is selected
    print("No key selected")
end




function touchKeyboard:touchreleased()
    self.selectedKey = nil
    print("TEST")
end

function touchKeyboard:getSelectedKey()
    return self.selectedKey
end


-- Function to rotate a point (x, y) around the origin by angle theta
function rotatePoint(x, y, theta)
    local cosTheta = math.cos(theta)
    local sinTheta = math.sin(theta)
    local rotatedX = x * cosTheta - y * sinTheta
    local rotatedY = x * sinTheta + y * cosTheta
    return rotatedX, rotatedY
end
--[[
function touchKeyboard:mousepressed(x, y, button, istouch, presses)
    --if button == 1 then -- Left mouse button
        self:touchpressed(x, y)
    --end
end

function touchKeyboard:mousereleased(x, y, button, istouch, presses)
    --if button == 1 then -- Left mouse button
        self:touchreleased()
    --end
end
--]]

-- Handle touchreleased event
function touchKeyboard:touchreleased()
    self.selectedKey = nil
end

-- Return the selected key
function touchKeyboard:getSelectedKey()
		return self.selectedKey
end



return touchKeyboard
